/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2011-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: SmpC1ISR.S 1801 2015-03-27 06:34:43Z t_ishikawa $
 */

#define TOPPERS_MACRO_ONLY

#define UINT_C(val)	(val)
#define CAST(type, val)	(val)	/* 㥹ȤԤޥ */

#include "kernel/kernel_impl.h"
#include "vic.h"
#include "nios2.h"
#include "target_test.h"

.global C1ISRMainSmpC1ISR
.set noat

C1ISRMainSmpC1ISR:
	addi	ea,	ea,	-4	/* Ϥǥ */

	/* 쥸¸ */
	addi	sp,	sp,	-76
	stw		at,		0(sp)
	stw		r2,		4(sp)
	stw		r3,		8(sp)
	stw		r4,		12(sp)
	stw		r5,		16(sp)
	stw		r6,		20(sp)
	stw		r7,		24(sp)
	stw		r8,		28(sp)
	stw		r9,		32(sp)
	stw		r10,	36(sp)
	stw		r11,	40(sp)
	stw		r12,	44(sp)
	stw		r13,	48(sp)
	stw		r14,	52(sp)
	stw		r15,	56(sp)
	stw		ra,		60(sp)
	stw		ea,		64(sp)
	rdctl	et,		estatus
	stw		et,		68(sp)

	rdctl   r2, status
	ori     r2, r2, STATUS_PIE
	wrctl   status, r2

	/* ȯcallevel_stat򥹥å¸ */
	ldh		r2,		%gprel(callevel_stat)(gp)
	stw		r2,		72(sp)


	/* callevel_statC1ISR򥻥å */
	ldhu	et,		%gprel(callevel_stat)(gp)
	ori		et,		et,	TSYS_ISR1
	sth		et,		%gprel(callevel_stat)(gp)

	/*
	 *  ޳ߤ򥯥ꥢ
	 */
	movia	et,		TIMER_STATUS(TIMER_5_IRQ)
	stwio	zero,	0(et)

	call	c1isr_syslog

	ldw		r2,		72(sp)
	sth		r2,		%gprel(callevel_stat)(gp)

	rdctl r2, status
	movi  r3, ~STATUS_PIE
	and   r2, r2, r3
	wrctl status, r2

	/* 쥸 */
	ldw		at,		0(sp)
	ldw		r2,		4(sp)
	ldw		r3,		8(sp)
	ldw		r4,		12(sp)
	ldw		r5,		16(sp)
	ldw		r6,		20(sp)
	ldw		r7,		24(sp)
	ldw		r8,		28(sp)
	ldw		r9,		32(sp)
	ldw		r10,	36(sp)
	ldw		r11,	40(sp)
	ldw		r12,	44(sp)
	ldw		r13,	48(sp)
	ldw		r14,	52(sp)
	ldw		r15,	56(sp)
	ldw		ra,		60(sp)
	ldw		ea,		64(sp)
	ldw		et,		68(sp)
	wrctl	estatus,	et
	addi	sp,	sp,	76

	eret
